var SECT_BEHAVIOR_NORMAL = 0;
var SECT_BEHAVIOR_FIXED = 1;

var sectionTypes = [
	{ id: 00, type: 'processor', icon: "Processor.png", englishName: "Processor usage", title: "", behavior: SECT_BEHAVIOR_NORMAL },
	{ id: 01, type: 'processor', icon: "ProcessorA.png", englishName: "Processor #A usage", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 02, type: 'processor', icon: "ProcessorB.png", englishName: "Processor #B usage", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 03, type: 'processor', icon: "Uptime.png", englishName: "Uptime", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 04, type: 'processor', icon: "Load.png", englishName: "Load average", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 05, type: 'processor', icon: "Frequency.png", englishName: "Processor frequency", title: "", behavior: SECT_BEHAVIOR_NORMAL  },	
	{ id: 06, type: 'memory', icon: "Memory.png", englishName: "Free memory", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 07, type: 'memory', icon: "MemoryUsed.png", englishName: "Used memory", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 08, type: 'memory', icon: "MemoryInactive.png", englishName: "Inactive memory", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 09, type: 'memory', icon: "MemoryWired.png", englishName: "Wired memory", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 10, type: 'memory', icon: "MemoryRatio.png", englishName: "Free memory ratio", title: "", behavior: SECT_BEHAVIOR_NORMAL  },	
	{ id: 11, type: 'storage', icon: "Storage.png", englishName: "Hard-drive free space", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 12, type: 'sensors', icon: "Sensors.png", englishName: "Processor temperature", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 13, type: 'sensors', icon: "Fan.png", englishName: "Fan rotation speed", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 14, type: 'network', icon: "NetworkDown.png", englishName: "Download traffic", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 15, type: 'network', icon: "NetworkUp.png", englishName: "Upload traffic", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 16, type: 'network', icon: "NetworkSpeeds.png", englishName: "Network bandwidth", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 17, type: 'network', icon: "NetworkUpDown.png", englishName: "Download+Upload", title: "", behavior: SECT_BEHAVIOR_FIXED  },	
	{ id: 18, type: 'network', icon: "AirportIcon.png", englishName: "AirPort signal", title: "", behavior: SECT_BEHAVIOR_FIXED  },		
	{ id: 19, type: 'battery', icon: "Battery.png", englishName: "Battery charge", title: "", behavior: SECT_BEHAVIOR_NORMAL  },
	{ id: 20, type: 'battery', icon: "BatteryTime.png", englishName: "Battery time remaining", title: "", behavior: SECT_BEHAVIOR_NORMAL  },	
	{ id: 21, type: 'battery', icon: "BatteryCycles.png", englishName: "Battery cycles", title: "" , behavior: SECT_BEHAVIOR_NORMAL },		
	{ id: 22, type: 'battery', icon: "BatteryMouse.png", englishName: "Wireless mouse", title: "", behavior: SECT_BEHAVIOR_NORMAL  },			
	{ id: 23, type: 'battery', icon: "BatteryKeyboard.png", englishName: "Wireless keyboard", title: "", behavior: SECT_BEHAVIOR_NORMAL }
];				
	
var defaultConfiguration = [ 0, 6, 11, 12, 14, 19 ];	

var notificationTypes = [
	{ id: 01, englishName: 'System load is too high', title: "" , enabled: false, extra: 'load >', trigger: 3.00, defaultTrigger: 3.00 },
	{ id: 02, englishName: 'Low free memory', title: "" , enabled: false, extra: 'M <', trigger: 15, defaultTrigger: 15 },
	{ id: 03, englishName: 'Processor is overheated', title: "" , enabled: true, extra: 'ºC >', trigger: 70, defaultTrigger: 70 },
	{ id: 04, englishName: 'Traffic counters reset', title: "" , enabled: true, extra: 'DISABLE', trigger: 0, defaultTrigger: 0 },
	{ id: 05, englishName: 'Battery is running low', title: "" , enabled: false, extra: '% <', trigger: 15, defaultTrigger: 15 } 
];

var currentActiveGrowlSelect = 0;  		
var checkYesGlyph = '✔';
var checkNoGlyph = '✕';	

var showExtraAppButton = widget.preferenceForKey("option-extrabutton");

function setOption(what, value)
{
	widget.setPreferenceForKey( value ? value : 0, "option-"+what);
	if ( what == 'extrabutton' ) 
		{
			showExtraAppButton = value;
			if (!value) 
				{
					o('extraAppPath').disabled = true;
					renderExtraAppButton(false);
				}
			else
				o('extraAppPath').disabled = false;
		}

}

function getOption(what)
{
	if ( what == 'extrabutton' ) return showExtraAppButton;
	var value = widget.preferenceForKey("option-"+what);
	if ( !value ) return 0;
	else return value;
}

function renderOptions()
{
	var tempValue = 0;
	
	if ( widget.preferenceForKey("unitType") == 'F' ) o('tempTypeSel').selectedIndex = 1;
	else o('tempTypeSel').selectedIndex = 0;
		
	if ( getOption('autolock') ) o('autolockCheck').checked = true;
	else setOption('autolock',0);
	
	
	if ( tempValue = getOption('extrabutton') ) 
		o('extraAppCheck').checked = true;	
	else
		{
			if ( tempValue == null ) 
				{
					setOption('extrabutton',1);
					 o('extraAppCheck').checked = true;	
				}
			else o('extraAppCheck').checked = false;	
		}

	if ( tempValue = getOption('save-state') ) 
		o('saveStateCheck').checked = true;	
	else
		{
			if ( tempValue == null ) 
				{
					setOption('save-state',1);
					 o('saveStateCheck').checked = true;	
				}
			else o('saveStateCheck').checked = false;	
		}
		
		
	if ( tempValue = getOption('disk-icons') ) 
		o('diskIconsCheck').checked = true;	
	else
		{
			if ( tempValue == null ) 
				{
					setOption('disk-icons',1);
					 o('diskIconsCheck').checked = true;	
				}
			else o('diskIconsCheck').checked = false;	
		}
	
	
	if ( tempValue = getOption('network-interface') ) 
		{
			changeNetworkInterface(tempValue);
		}
	else 
		{
			var newIntef = getIntefWithMaxTraffic();
			setOption('network-interface',newIntef);
			changeNetworkInterface(newIntef);
		}
	
	if ( tempValue = getOption('extrabuttonpath') ) o('extraAppPath').value = tempValue;
	else setOption('extrabuttonpath',"Activity Monitor");	
	
	///update times
	
	if ( tempValue = getOption('reset-day') ) 
		 { 
		 	o('resetDayInput').value = tempValue;
		 	changeResetDay(tempValue);
		 }
	else
		setOption('reset-day',1);
	
	
	if ( tempValue = getOption('update-processor') ) 
		 { if ( tempValue == 2 ) o('updateTimeProcessor').selectedIndex = 1; }
	else
		setOption('update-processor',1);
		
	if ( tempValue = getOption('update-memory') ) 
		 { 
		 	if ( tempValue == 2 ) o('updateTimeMemory').selectedIndex = 0; 
		 	else if ( tempValue == 5 ) o('updateTimeMemory').selectedIndex = 2; 
		 }
	else
		setOption('update-memory',3);	
		
			
	
	if ( tempValue = getOption('update-storage') ) 
		 { 
		 	if ( tempValue == 2 ) o('updateTimeStorage').selectedIndex = 0; 
		 	else if ( tempValue == 8 ) o('updateTimeStorage').selectedIndex = 2; 
		 }
	else
		setOption('update-storage',4);	

	if ( tempValue = getOption('update-sensors') ) 
		 { 
		 	if ( tempValue == 2 ) o('updateTimeSensors').selectedIndex = 0; 
		 	else if ( tempValue == 8 ) o('updateTimeSensors').selectedIndex = 2; 
		 }
	else
		setOption('update-sensors',5);	

	if ( tempValue = getOption('update-network') ) 
		 { 
		 	if ( tempValue == 2 ) o('updateTimeNetwork').selectedIndex = 1; 
		 	else if ( tempValue == 3 ) o('updateTimeNetwork').selectedIndex = 2; 
		 }
	else
		setOption('update-network',1);	

	if ( tempValue = getOption('update-battery') ) 
		 { 
		 	if ( tempValue == 4 ) o('updateTimeBattery').selectedIndex = 0; 
		 	else if ( tempValue == 9 ) o('updateTimeBattery').selectedIndex = 2; 
		 }
	else
		setOption('update-battery',8);	
	
	if ( tempValue = getOption('desktop-color') ) 
		{
			changeDesktopColor(tempValue);
			var selObj = o('desktopColorSel');
			for(var i=0; i<selObj.length; i++)
				{
					if( tempValue == selObj.options[i].value ) { selObj.selectedIndex = i; break; }
				}
		}
	else
		setOption('desktop-color',"#FFFFFF|black");
		

	if ( tempValue = getOption('wallpaperPic') ) 
		{
			var selObj = o('wallpaperSel');
			for(var i=0; i<selObj.length; i++)
			 {
		 		if( tempValue == selObj.options[i].value ) { selObj.selectedIndex = i; break; }
			 }
		}
	else
		setOption('wallpaperPic','StandardAqua.png');


	if ( tempValue = getOption('growl-interval') ) 
		{
			var selObj = o('growlCheckTimes');
			for(var i=0; i<selObj.length; i++)
				{
					if( tempValue == selObj.options[i].value ) { selObj.selectedIndex = i; break; }
				}
		}
	else
		setOption('growl-interval',30);
		
	if ( tempValue = getOption('growl-mode') ) 
		{
			var selObj = o('growlDisableSel');
			for(var i=0; i<selObj.length; i++)
				{
					if( tempValue == selObj.options[i].value ) { selObj.selectedIndex = i; break; }
				}
		}
	else
		setOption('growl-mode',1);		

	if ( tempValue = getOption('counters-type') ) 
		{
			changeTrafficResetType(tempValue);
			setResetButtonPic(tempValue);
			var selObj = o('trafficCounterTypeSel');
			for(var i=0; i<selObj.length; i++)
				{
					if( parseInt(tempValue) == parseInt(selObj.options[i].value) ) { selObj.selectedIndex = i; break; }
				}
			switchDaySelect(tempValue == '6');
		}
	else
		{ setOption('counters-type',1); switchDaySelect(false); }

	setCurrentLayout( getOption('layout')+1 || 1 );
	
//	updateSectionSelects(-1,0); //all
	
	for(var i=0; i<notificationTypes.length; i++)
		{
			var value = getOption('growl-trigger-'+(i+1));
			if (!value) { value = notificationTypes[i].defaultTrigger; setOption('growl-trigger-'+(i+1),value); }
			notificationTypes[i].trigger = value;
			value = widget.preferenceForKey('option-growl-enabled-'+(i+1));
			if (!value && value!=0) { value = notificationTypes[i].enabled; setOption('growl-enabled-'+(i+1),value); }
			notificationTypes[i].enabled = value;			
		}
	
	if ( parseInt(getOption('language')) ) o('languageSel').selectedIndex = 1;
	

	
}

function rephraseSectionSelectsItems(fromWhat,toWhat)
{
	var updateAllTypes = ( fromWhat == -1 && toWhat == -1 );
	fromWhat = parseInt(fromWhat);
	toWhat = parseInt(toWhat);
	
	for (var i=1;i<=6;i++)
		{
			var selSectionsObj = o('section'+i+'select');
			for ( var op=0; op<selSectionsObj.options.length; op++)
				{
					if ( !updateAllTypes && !( op == fromWhat || op == toWhat ) ) continue;							
					var opStr = selSectionsObj.options[op].innerHTML;
					opStr = opStr.replace(/\s\[.*\]/,"");
					selSectionsObj.options[op].innerHTML = opStr;
					selSectionsObj.options[op].tag = 0;
				}
		}
	
	var curTable = [ [0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0] ];
	for(var c=0;c<=1;c++)
		{
			for(var i=1;i<=6;i++)
				curTable[c][i-1] = getOption('section'+i+'at'+c)||defaultConfiguration[i-1]||0;
		}
		
	var selSectionsObjFirst = o('section1select');	

	for (var c=0;c<=1;c++)
		{
			for (var i=1;i<=6;i++)
				{	
					if ( selSectionsObjFirst.options[curTable[c][i-1]].tag ) continue;
					
					var addStr = " ["+(c+1)+"]";
					var foundInAnotherLayout = false;
					for (var y=1;y<=6;y++)
						{
							if ( curTable[c][i-1] == curTable[c==1?0:1][y-1] ) foundInAnotherLayout = true;
						}
						
					if ( foundInAnotherLayout ) addStr = " [1,2]";
					selSectionsObjFirst.options[curTable[c][i-1]].tag = 1;
					selSectionsObjFirst.options[curTable[c][i-1]].innerHTML += addStr;					
				}
		}

	for (var x=2;x<=6;x++)
		{	
			var selSectionsObj = o('section'+x+'select');
			for ( var i=0; i < selSectionsObjFirst.options.length; i++ )
				selSectionsObj.options[i].innerHTML = selSectionsObjFirst.options[i].innerHTML;
		}
}

function updateSectionSelects(what,toWhat)
{
	var STARTVAR = 1;
	var ENDVAR = 6;
	
	if ( what != -1 )
		{ STARTVAR = ENDVAR = what; }
		
	for(var i=STARTVAR;i<=ENDVAR;i++)
		{
			var selSectionsObj = o('section'+i+'select');
			var optionValue = (what!=-1) ? toWhat : getOption('section'+i+'at'+CSL)||defaultConfiguration[i-1]||0;
		
			if ( sectionTypes[optionValue].icon != "Fan.png" ) 
				o('section'+i+'example').src = 'Icons/'+sectionTypes[optionValue].icon;
			else
				o('section'+i+'example').src = 'Icons/FanOnBlack.png';
			
			if ( what == -1 )
				{			
					changeOneSection(i,optionValue);
				
					for(var sectType in sectionTypes)
						{
							selSectionsObj.options[sectType] = new Option(sectionTypes[sectType].title,sectionTypes[sectType].id);		
							if (optionValue == sectType) selSectionsObj.options[sectType].selected = true;
						}
				}
			else 
				selSectionsObj.selectedIndex = parseInt(optionValue);
		}
		
	setTimeout('rephraseSectionSelectsItems(-1,-1);',100);
}

function changeSection(what,value)
{
	var oldValue = getOption('section'+what+'at'+CSL)||defaultConfiguration[what-1]||0;
	setOption('section'+what+'at'+CSL,value);
	if ( sectionTypes[value].icon != "Fan.png" ) 
		o('section'+what+'example').src = 'Icons/'+sectionTypes[value].icon;
	else
		o('section'+what+'example').src = 'Icons/FanOnBlack.png';
	
	changeOneSection(what,value);
	rephraseSectionSelectsItems(oldValue,value);
	resetUpdateCounters();
}

function switchDaySelect(show)
{
	o('resetDayInput').style.display = show ? 'block' : 'none';
	o('trafficCounterTypeSel').style.width = show ? '76px' : '103px';
}


function openExtraApp()
{
	var app = getOption('extrabuttonpath');
	if ( !app ) app = "Activity Monitor";
	if ( !miniStatCore.launchAppWithName_(app) )
		miniStatCore.launchAppWithName_("Activity Monitor"); 
}

function savePrefs(what)
{
	switch(what)
		{
			case 'extrabutton':
				var value = o('extraAppPath').value;
				if ( !value ) value = o('extraAppPath').value = "Activity Monitor";
				setOption('extrabuttonpath',value);
				break;
			case 'growl-trigger':
				if ( currentActiveGrowlSelect == 0 ) break;
				var value = parseFloat(o('growlTriggerInput').value);
				if (!value || value<0)	value = notificationTypes[currentActiveGrowlSelect-1].defaultTrigger;
				var units = widget.preferenceForKey("unitType");
				if ( currentActiveGrowlSelect == 3 && units == 'F' ) value = (10/18)*(value - 32);	
				setOption('growl-trigger-'+currentActiveGrowlSelect,value);
				notificationTypes[currentActiveGrowlSelect-1].trigger = parseFloat(value);
				break;
		}
}

function changeUpdateTime(what,value)
{
	setOption("update-"+what,value);
	changeTimes(what,value);
}

function changeDesktopColor(value)
{
	var colors = value.split("|");	
	var textToChange = [ 'sampleTextColor', 'procSumValue', 'memSumValue', 'storSumValue', 'sensSumValue', 'netwSumValue', 'battSumValue' ];

	o('summaryHint').style.color = colors[0];
	o('summaryHint').style.textShadow = "0px 0px 3px "+colors[1];

	for(obj in textToChange)
		{
			o(textToChange[obj]).style.color = colors[0];
			o(textToChange[obj]).style.textShadow = "0px 0px 2px "+colors[1];
		}
		
	o('vertLine').style.borderLeft = "2px solid "+colors[0];
	o('vertLineSmall').style.borderLeft = "2px solid "+colors[0];	
}

function resetInterface(toWhat)
{
	setOption('network-interface',toWhat);
	changeNetworkInterface(toWhat);
	fillInterfacesList();
}



function fillInterfacesList()
{
	var intefCount = 0; 
	var infoList = miniStatCore.updateNetwork_("0");		
	if ( infoList ) intefCount = infoList.length;	

	var foundInterface = -1;
	var monitoringInterface = getOption('network-interface');
		
	var netwSelects = [ o('networkInterfaceSel'), o('intefSelect') ];
	
	for( selObj in netwSelects )
		{
			var curObj = netwSelects[selObj];
			
			for(var y=0;y<curObj.length;y++)
				curObj.options[y] = null;
	
			for(var i=0;i<intefCount;i++) 
				{
					var intefName = infoList[i][0];
					var n = formatNumber(infoList[i][2]*1024); 
					var m = formatNumber(infoList[i][1]*1024); 
					var intefDescription = "";
					switch(intefName)
						{
							case 'en0':
									intefDescription = "Ethernet"; break;
							case 'en1':
									intefDescription = "AirPort*"; break;					
							case 'ppp0':
							case 'ppp1':
									intefDescription = "VPN, Dial-up"; break;	
							case 'fw0':
							case 'fw1':
									intefDescription = "Firewire"; break;						
						}
						
					if ( intefDescription ) intefDescription = " (" + intefDescription + ")";
						
					curObj.options[i] = new Option(intefName+intefDescription+" - "+m.num+m.type+'↓ / '+n.num+n.type+'↑',intefName);			
					if ( monitoringInterface == intefName )
					curObj.options[i].selected = true;
			}
		}
}

function fillGrowlList()
{
	var selObj = o('growlNotificationSel');
	
	for(var y=0;y<selObj.length;y++)
		selObj.options[y] = null;
		
	selObj.options[0] = new Option(getLocalizedString('-Select notification type to edit-'),0);
	var cntr = 0;

	notificationTypes[2].extra = 'º'+unitType+' >';

	for (var notif in notificationTypes)
		{
				var addStr = getOption('growl-enabled-'+notificationTypes[notif].id) ? checkYesGlyph : checkNoGlyph;
				selObj.options[++cntr] = new Option(addStr+' '+notificationTypes[notif].title,notificationTypes[notif].id);				
		}
		
		


}

function switchNotificationTypeSel(what)
{	
	var type = parseInt(what);
	var selObj = o('growlNotificationSel');
	
	selObj.selectedIndex = type;
	
	if ( type != 0 )
		{
			o('growlNotificationEnabled').checked = getOption('growl-enabled-'+type) ? 1 : 0;
			var units = widget.preferenceForKey("unitType");
			var value = getOption('growl-trigger-'+type) || notificationTypes[type-1].trigger || notificationTypes[type-1].defaultTrigger || 10;

			if ( type == 3 && units == 'F' ) o('growlTriggerInput').value = parseInt(1.8*parseFloat(value)+32);
			else o('growlTriggerInput').value = type==3 ? parseInt(value) : value;
		}
	else
		o('growlNotificationEnabled').checked = false;

	var showOptions = type != 0 && (notificationTypes[type-1].extra != 'DISABLE') 
	o('growlTriggerExtra').innerText = showOptions ? notificationTypes[type-1].extra : '---'; 
	o('growlNotificationEnabled').disabled = (type == 0);
	o('growlNotificationEnabledLabel').style.opacity = (type != 0) ? 1.0 : 0.5;			
	o('growlTriggerOnLabel').style.opacity = showOptions ? 1.0 : 0.5;
	o('growlTriggerInput').style.opacity = showOptions ? 1.0 : 0.5;	
	o('growlTriggerInput').disabled = !showOptions;
	if ( !showOptions) o('growlTriggerInput').value = '---';	
	
	currentActiveGrowlSelect = type;

}

function changeGrowlEnabled(check)
{
	setOption('growl-enabled-'+currentActiveGrowlSelect, check ? 1 : 0 );
	notificationTypes[currentActiveGrowlSelect-1].enabled = check;
	o('growlNotificationSel').options[currentActiveGrowlSelect].innerText = (check ? checkYesGlyph : checkNoGlyph) + ' ' + notificationTypes[currentActiveGrowlSelect-1].title;
}

function fireGrowlUpdate()
{
	if ( getOption('growl-mode') == '2' && miniStatCore.isUserIdle()) return;
	
	miniStatCore.checkGrowlUpdates____( notificationTypes[0].enabled ? notificationTypes[0].trigger : -1,
																notificationTypes[1].enabled ? notificationTypes[1].trigger : -1,
																notificationTypes[2].enabled ? notificationTypes[2].trigger : -1,
																notificationTypes[4].enabled ? notificationTypes[4].trigger : -1);

}

function prefsPrepare()
{
		setCounterValuesForPrefs(true);
		fillInterfacesList();	
		fillGrowlList();
		
		var growlEnabled = miniStatCore.growlPresents();
		
		o('growlNotificationSel').disabled = !growlEnabled;
		o('growlCheckTimes').disabled = !growlEnabled;
		o('growlDisableSel').disabled = !growlEnabled;		

}
